package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.CreateChange;
import com.perforce.hws.core.p4base.HasGson;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.route.UsesJsonRequests;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;
import com.perforce.p4client.models.ChangelistRequest;

/**
 * POST /p4/:api/changes
 */
public class PerforceAddChangeRoute implements
        spark.Route,
        HasGson,
        ModelConversion,
        UsesJsonRequests,
        UsesServerHandles {

    @Override
    public Object handle(spark.Request request, spark.Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");

        ChangelistRequest changeRequest = readModel(request, ChangelistRequest.class);

        return withServerHandle(server, sessionData, settings, serverHandle -> {
            CreateChange createChange = new CreateChange(serverHandle);

            return toCommandResponse(createChange.apply(changeRequest));
        });
    }
}
