package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.HasGson;
import com.perforce.hws.core.p4base.P4Methods;
import com.perforce.hws.core.p4base.ResultMap;
import com.perforce.hws.core.p4base.ResultMapMethods;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.route.UsesJsonRequests;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;
import com.perforce.p4client.models.StreamCommand;

/**
 * POST /p4/:api/streams
 */
public class PerforceAddStreamRoute implements
        spark.Route,
        ModelConversion,
        P4Methods,
        HasGson,
        ResultMapMethods,
        UsesJsonRequests,
        UsesServerHandles {

    @Override
    public Object handle(spark.Request request, spark.Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");

        StreamCommand streamCommand = readModel(request, StreamCommand.class);

        java.util.Map<String, Object> requestMap = toRequestMap(streamCommand);

        return withServerHandle(server, sessionData, settings, serverHandle -> {
            java.util.List<ResultMap> resultMaps =
                    execInput(serverHandle, requestMap, "stream", "-i");

            return toCommandResponse(resultMaps);
        });
    }
}