package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.P4Methods;
import com.perforce.hws.core.p4base.ResultMap;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;
import spark.Request;
import spark.Response;
import spark.Route;

import java.util.List;
import java.util.function.Supplier;
import java.util.stream.Collectors;

/**
 * GET /p4/:api/clients/:client
 */
public class PerforceGetClientRoute implements
        Route,
        P4Methods,
		ModelConversion,
		UsesServerHandles {

    @Override
    public Object handle(Request request, Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");

        return withServerHandle(server, sessionData, settings, serverHandle -> {
            List<ResultMap> resultMapList = exec(serverHandle, "clients");
            Supplier<String> offsetSupplier = offsetSupplier(serverHandle);
            return resultMapList.stream().map(m -> toClientsCommand(m, offsetSupplier))
                    .collect(Collectors.toList());
        });
    }
}
