package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.ServerHandle;
import com.perforce.hws.route.ProvidesLoginRoute;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.UsesServerHandles;
import com.perforce.hwsclient.models.LoginRequest;
import com.perforce.hwsclient.models.LoginResponse;

import static spark.Spark.halt;

/**
 * Provides a means for logging in to a p4d instance.
 */
public class PerforceLoginRoute implements spark.Route, ProvidesLoginRoute, UsesServerHandles {

    @Override
    public Object handle(spark.Request request, spark.Response response) throws Exception {
        HWSSettings settings = request.attribute("settings");

        String serverId = request.params("server");

        LoginRequest loginRequest = gson.fromJson(request.body(), LoginRequest.class);

        LoginResponse loginResponse = new LoginResponse();

        try (ServerHandle serverHandle = obtainServerHandle(serverId, settings)) {
            if (serverHandle == null) {
                halt(403, "No server");
            }
            String p4ticket = logIn(serverHandle, loginRequest.getUser(), loginRequest.getPassword(), true);
            loginResponse.setTicket(p4ticket);
        }

        return handleLoginResponse(loginResponse, request, response);
    }
}
