package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.HasGson;
import com.perforce.hws.core.p4base.P4Methods;
import com.perforce.hws.core.p4base.ResultMap;
import com.perforce.hws.core.p4base.ResultMapMethods;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.route.UsesJsonRequests;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;
import com.perforce.p4client.models.DepotCommand;

/**
 * PATCH /p4/:api/branches/:branch
 */
public class PerforceUpdateDepotRoute implements
		spark.Route,
		P4Methods,
		ResultMapMethods,
		HasGson,
		ModelConversion,
		UsesJsonRequests,
		UsesServerHandles {

	@Override
	public Object handle(spark.Request request, spark.Response response) throws Exception {
		SessionData sessionData = request.attribute("sessionData");
		HWSSettings settings = request.attribute("settings");

		String server = request.params("server");
		String depot = request.params("depot");

		DepotCommand depotCommand = readModel(request, DepotCommand.class);

		return withServerHandle(server, sessionData, settings, serverHandle -> {
			java.util.Map<String, Object> updates = toRequestMap(depotCommand);

			java.util.List<ResultMap> results = exec(serverHandle, "depot", "-o", depot);
			ResultMap resultMap = firstResultOrFail(results);

			java.util.Map<String, Object> current = toRequestMap(toDepotCommand(resultMap));

			current.putAll(updates);

			return toCommandResponse(execInput(serverHandle, current, "depot", "-i"));
		});
	}
}
